<template>
  <v-container>
    <div style="display: flex; justify-content: center">
      <apexchart
        width="1000"
        type="bar"
        :options="options"
        :series="series"
      ></apexchart>
    </div>
  </v-container>
</template>

<script>
import moment from "moment";
export default {
  name: "Chart",
  props: {
    Cases: [],
    Deaths: [],
    Recovereds: [],
    Date: [],
  },
  // data: () => ({}),
  data: function () {
    return {
      options: {
        chart: {
          id: "vuechart-example",
        },
        xaxis: {
          categories: [1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998],
        },
        dataLabels: {
          enabled: false,
        },
        colors:['#90CAF9', '#D50000', '#00E676']
      },
      series: [
        {
          name: "series-1",
          data: [30, 40, 45, 50, 49, 60, 70, 91],
        },
      ],
    };
  },
  watch: {
    Date() {
      if (this.Date.length == 0) {
        this.setdefaultData();
      } else {
        this.setData();
      }
    },
    Cases() {
      this.setdefaultData();
    },
  },
  methods: {
    setData() {
      
      let newCases = [...this.Cases];
      let ArrayCases = newCases.filter((data) => {
        for (let i = 0; i < this.Date.length; i++) {
          const dateCheck = moment(this.Date[i]).format("M/DD/YY");
          if (data.day == dateCheck) {
            return data;
          }
        }
      });
      let qurryedCases = [];
      let qurryedDay = [];
      ArrayCases.forEach((data) => {
        qurryedCases.push(data.cases);
        qurryedDay.push(data.day);
      });
      
      let newDeath = [...this.Deaths];
      let ArrayDeath = newDeath.filter((data) => {
        for (let i = 0; i < this.Date.length; i++) {
          const dateCheck = moment(this.Date[i]).format("M/DD/YY");
          if (data.day == dateCheck) {
            return data;
          }
        }
      });
      let qurryedDeath = [];
      ArrayDeath.forEach((data) => {
        qurryedDeath.push(data.deaths);
      });
      
      let newRecovered = [...this.Recovereds];
      let ArrayRecovered = newRecovered.filter((data) => {
        for (let i = 0; i < this.Date.length; i++) {
          const dateCheck = moment(this.Date[i]).format("M/DD/YY");
          if (data.day == dateCheck) {
            return data;
          }
        }
      });
      console.log(ArrayRecovered);
      let qurryedRecovered = [];
      ArrayRecovered.forEach((data) => {
        qurryedRecovered.push(data.recoves);
      });
      
      (this.options = {
        chart: {
          id: "vuechart-example",
        },
        xaxis: {
          categories: qurryedDay,
        },
      }),
        (this.series = [
          {
            name: "Cases",
            data: qurryedCases,
          },
          {
            name: "Deaths",
            data: qurryedDeath,
          },
          {
            name: "recoves",
            data: qurryedRecovered,
          },
        ]);
    },
    setdefaultData() {
      
      let defaultDay = this.Cases.map((data) => {
        return data.day;
      });
      let defaultCases = this.Cases.map((data) => {
        return data.cases;
      });
      let defaultDeaths = this.Deaths.map((data) => {
        return data.deaths;
      });
      let defaultRecovereds = this.Recovereds.map((data) => {
        return data.recoves;
      });
      
      (this.options = {
        chart: {
          id: "vuechart-example",
        },
        xaxis: {
          categories: defaultDay,
        },
      }),
        (this.series = [
          {
            name: "Cases",
            data: defaultCases,
          },
          {
            name: "Deaths",
            data: defaultDeaths,
          },
          {
            name: "recoves",
            data: defaultRecovereds,
          },
        ]);
    },
  },
};
</script>
